﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using System.ComponentModel;

namespace xamDataGrid1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public ObservableCollection<Person> Items = new ObservableCollection<Person>();

        public MainWindow()
        {
            InitializeComponent();
            RefreshData();
            xamGrid.DataSource = Items;
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            RefreshData();
        }

        public void RefreshData()
        {
            Items.Clear();

            Items.Add(new Person { Age = 20, Name = "John", IsFieldDirty = false });
            Items.Add(new Person { Age = 30, Name = "Rudy", IsFieldDirty = false });
            Items.Add(new Person { Age = 31, Name = "Toby", IsFieldDirty = false });

            for (int i = 0; i < 50; i++)
            {
                Items.Add(new Person { Age = i, Name = "Toby", IsFieldDirty = false });
            }
        }

        private void Button_Click_1(object sender, RoutedEventArgs e)
        {
            Items[0].Age = 23;
        }
    }

    public class Person : INotifyPropertyChanged
    {
        private bool _isFieldDirty;
        public bool IsFieldDirty
        {
            get { return _isFieldDirty; }
            set
            {
                _isFieldDirty = value;
                PropertyChanged(this, new PropertyChangedEventArgs("IsFieldDirty"));
            }
        }

        private string _name;
        public string Name
        {
            get { return _name; }
            set
            {
                _name = value;
                PropertyChanged(this, new PropertyChangedEventArgs("Name"));
            }
        }

        private int _age;
        public int Age
        {
            get { return _age; }
            set
            {
                _age = value;
                IsFieldDirty = true;
                PropertyChanged(this, new PropertyChangedEventArgs("Age"));
            }
        }

        public event PropertyChangedEventHandler PropertyChanged = delegate { };


    }
}
